﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Data;
using Infragistics.UltraChart.Core.Primitives;

namespace UltraChartGanttChartExcludeRow
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


            DataTable dt = new DataTable();
            dt.Columns.Add("StartDate", typeof(DateTime));
            dt.Columns.Add("EndDate", typeof(DateTime));
            dt.Columns.Add("Owner", typeof(string));
            dt.Columns.Add("Label", typeof(string));
            dt.Columns.Add("PercentComplete", typeof(int));
            dt.Columns.Add("Links", typeof(int));

            dt.Rows.Add(DateTime.Today, DateTime.Today.AddDays(1), "Owner 1", "Test 1", 0, 1);
            dt.Rows.Add(DateTime.Today.AddDays(2), DateTime.Today.AddDays(4), "Owner 2", "Test 2", 25,2);
            dt.Rows.Add(DateTime.Today.AddDays(1), DateTime.Today.AddDays(1), "Owner 3", "Test 3", 75, 1);
            dt.Rows.Add(DateTime.Today.AddDays(3), DateTime.Today.AddDays(6), "Owner 4", "Test 4", 100, 2);



            ultraChart1.GanttChart.Columns.StartTimeColumnIndex = 0;
            ultraChart1.GanttChart.Columns.EndTimeColumnIndex = 1;
            ultraChart1.GanttChart.Columns.OwnerColumnIndex = 2;
            ultraChart1.GanttChart.Columns.ItemLabelsColumnIndex = 3;
            ultraChart1.GanttChart.ShowLinks = true;
            ultraChart1.GanttChart.ShowCompletePercentages = true;
            ultraChart1.GanttChart.Columns.PercentCompleteColumnIndex = 4;
            ultraChart1.GanttChart.Columns.LinkToColumnIndex = 5;


            ultraGrid1.DataSource = dt;
            ultraChart1.DataSource = dt;
            ultraChart1.Tooltips.Display = Infragistics.UltraChart.Shared.Styles.TooltipDisplay.MouseMove;
            ultraChart1.Axis.X.Margin.Far.Value = 10;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            List<Primitive> listPr = new List<Primitive>();
            foreach (Primitive pr in e.SceneGraph)
            {
                if (pr.GetType() == typeof(Box) && pr.Column != -1 && pr.Row != -1)
                {
                    int k = ((Box)pr).rect.Width;
                    DateTime[] dt = ((Box)pr).Value as DateTime[];

                    // Milestone
                    if (dt != null && dt[0] == dt[1])
                    {

                        
                        ((Box)pr).rect = new Rectangle(((Box)pr).rect.X - (((Box)pr).rect.Height / 2), ((Box)pr).rect.Y, ((Box)pr).rect.Height, ((Box)pr).rect.Height);
                        ((Box)pr).PE.FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle.None;
                        ((Box)pr).PE.Fill = Color.Red;
                        ((Box)pr).RotationAngle = 45;
                    }
                    // Stoppage (Break)
                    if (dt != null && dt[0].AddDays(2) < dt[1])
                    {
                        // Start position + 50 ; // Breake duration 120
                        ((Box)pr).rect = new Rectangle(((Box)pr).rect.X + 50, ((Box)pr).rect.Y, 120, ((Box)pr).rect.Height);
                        ((Box)pr).PE.FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle.None;
                        ((Box)pr).PE.Fill = Color.Orange;
                       // ((Box)pr).RotationAngle = 45;
                    }
                }
            }
        }
    }
}
